module AbsSML where

import PackedString
import Ix

data SMLNG
    = Text PackedString
    | Tag Bool TagSort -- Open == True
    | WS WhiteSpace
      deriving (Show,Eq)

data WhiteSpace = SPC | CR | LF | TAB deriving (Show,Eq)

data TagSort
     = Bold
     | Emphasis
     | Italic
     | Plaintext
     | Strong
     | TT
     | Underline
     | Size !Int
     | Color Color
       deriving (Show,Eq,Ord)

cost :: TagSort -> Int
cost Bold = 3
cost Emphasis = 4
cost Italic = 3
cost Plaintext = 4
cost Strong = 3
cost TT = 4
cost Underline = 3
cost (Size _) = 3
cost (Color _) = 3

data Color
     = Red
     | Green
     | Blue
     | Cyan
     | Mangenta
     | Yellow
     | Black
     | White
-- For init state
     | Dunno
       deriving (Show,Eq,Ord,Ix)
       
colorEq Dunno _ = True
colorEq _ Dunno = True
colorEq c1 c2   = c1 == c2
