module RedundancyElim(redundElim) where

import SMLtree
import State

redundElim :: [SMLtree] -> [SMLtree]
redundElim = concatMap (elim initState)

elim state (TagNode Bold ch) | b state = concatMap (elim state) ch
elim state (TagNode Emphasis ch) | s state = concatMap (elim state) ch
elim state (TagNode Emphasis [TagNode Emphasis ch]) = concatMap (elim state) ch
elim state (TagNode Italic ch) | i state = concatMap (elim state) ch
elim state (TagNode Plaintext ch)
 | u state == 0 && not (s state) && not (em state) && not (i state)
   && not (b state) && not (tt state) = concatMap (elim state) ch
elim state (TagNode Strong ch) | s state = concatMap (elim state) ch
elim state (TagNode TT ch) | tt state = concatMap (elim state) ch
elim state (TagNode Underline ch) | u state > 2 = concatMap (elim state) ch
elim state (TagNode (Size s) ch) | size state == s = concatMap (elim state) ch
elim state (TagNode (Color c) ch) | color state == c
  = concatMap (elim state) ch
elim state (TagNode tag ch)
  = [TagNode tag (concatMap (elim (newState state tag)) ch)]
elim state s = [s]
