module SortSharing(sortSharing,canonical) where

import SMLtree
import List

-- This algorithm is pretty nave
-- Run preferrably after RedundancyElim

sortSharing = sortShare . canonical

sortShare :: [MultiTree] -> [MultiTree]
sortShare (TagMulti ts1 ch1:TagMulti ts2 ch2:ss) | not $ null common
 = sortShare
 	(TagMulti common (dropEmpty [TagMulti (drop (length common) ts1) ch1
 			            ,TagMulti (drop (length common) ts2) ch2]) : ss)
  where common = foldr (\(a,b) rest -> if a==b then a:rest else []) [] (zip ts1 ts2)
sortShare (TagMulti tag ch:ss) = TagMulti tag (sortShare ch): sortShare ss
sortShare (s:ss) = s : sortShare ss
sortShare [] = []

dropEmpty (TagMulti [] ch:ss) = ch ++ dropEmpty ss
dropEmpty (s:ss) = s : dropEmpty ss

-- Here's a pass trying put tags in a more canonical form
-- It's rather silly but it's a try anyway...

canonical :: [MultiTree] -> [MultiTree]
canonical = map canon

canon (TagMulti tags ch) = TagMulti (mkCanon tags) (canonical ch)
canon s = s

mkCanon list | safe list = sort list
mkCanon list = list

--safe list = False

safe list = Plaintext `notElem` list && colors < 2
            && countSize list < 2 && not (Underline `elem` list && colors > 0)
            && not (Strong `elem` list && Emphasis `elem` list)
  where colors = countColors list

countColors = sum . map col
  where col (Color _) = 1
        col _ = 0
countSize = sum . map siz
  where siz (Size _) = 1
        siz _ = 0
