module State where

import AbsSML

data State = State
	{ b,em,i,s,tt :: Bool,
	  u,size :: Int,
	  color :: Color } deriving Show

initState = State {b=False,em=False,i=False,s=False,tt=False,u=0,size=(-1),color=Dunno}

newState state Bold = state{b=True}
newState state Emphasis = if not (s state) then
				state{em=not(em state)}
			  else state
newState state Italic = state{i=True}
newState state Plaintext = state{u=0,s=False,em=False,i=False,b=False,tt=False}
newState state Strong = state{s=True,em=False}
newState state TT = state{tt=True}
newState state Underline = state{u=incU (u state)}
  where incU n | n < 3 = n+1
  	incU n         = n
newState state (Size i) = state{size=i}
newState state (Color col) = state{color=col}
